/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @package    RobotAPI::ArmarXObjects::FrameTracking
 * @author     Adrian Knobloch ( adrian dot knobloch at student dot kit dot edu )
 * @date       2019
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#define BOOST_TEST_MODULE RobotAPI::ArmarXObjects::ArViz

#define ARMARX_BOOST_TEST

#include <RobotAPI/Test.h>
#include <RobotAPI/components/ArViz/Client/elements/point_cloud_type_traits.hpp>

#include <iostream>


namespace
{

    struct PointXYZ
    {
        float x, y, z;
    };

    struct PointXYZRGBA
    {
        float x, y, z;
        uint8_t r, g, b, a;
    };

    struct PointXYZRGBL
    {
        float x, y, z;
        uint8_t r, g, b, a;
        uint32_t label;
    };

}


BOOST_AUTO_TEST_CASE(test_has_member_rgba)
{
    static_assert(!armarx::viz::detail::has_members_rgba<PointXYZ>::value,
                  "has_members_rgba<PointXYZ>::value must be false.");

    static_assert(armarx::viz::detail::has_members_rgba<PointXYZRGBA>::value,
                  "has_members_rgba<PointXYZRGBA>::value must be true.");

    static_assert(armarx::viz::detail::has_members_rgba<PointXYZRGBL>::value,
                  "has_members_rgba<PointXYZRGBL>::value must be true.");


    static_assert(!armarx::viz::detail::has_member_label<PointXYZ>::value,
                  "has_member_label<PointXYZ>::value must be false.");

    static_assert(!armarx::viz::detail::has_member_label<PointXYZRGBA>::value,
                  "has_member_label<PointXYZRGBA>::value must be false.");

    static_assert(armarx::viz::detail::has_member_label<PointXYZRGBL>::value,
                  "has_member_label<PointXYZRGBL>::value must be true.");

    BOOST_CHECK_EQUAL(true, true);
}
