#pragma once

#include <RobotAPI/interface/aron.ice>


module armarx
{
    module armem
    {
        module data
        {
            struct AddSegmentInput
            {
                string coreSegmentName;
                string providerSegmentName;

                bool clearWhenExists = false;
            };
            sequence<AddSegmentInput> AddSegmentsInput;

            struct AddSegmentResult
            {
                bool success = false;
                string segmentID;

                string errorMessage;
            };
            sequence<AddSegmentResult> AddSegmentsResult;


            struct EntityUpdate
            {
                string entityID;
                aron::AronDataList instancesData;
                long timeCreatedMicroSeconds;

                float importance;
                long timeSentMicroSeconds;
            };
            sequence<EntityUpdate> EntityUpdateList;

            struct EntityUpdateResult
            {
                bool success = false;

                string snapshotID;
                long timeArrivedMicroSeconds;

                string errorMessage;
            };
            sequence<EntityUpdateResult> EntityUpdateResultList;

            struct Commit
            {
                EntityUpdateList updates;
            };
            struct CommitResult
            {
                EntityUpdateResultList results;
            };
        }


        interface WritingInterface
        {
            /// Register multiple core or provider segments.
            data::AddSegmentsResult addSegments(data::AddSegmentsInput input);
            // void removeSegments();

            /// Commit data to the memory.
            data::CommitResult commit(data::Commit commit);
        };

    };
};
