#include "GraspCandidateObserverComponentPlugin.h"

namespace armarx
{
    namespace plugins
    {

        void GraspCandidateObserverComponentPlugin::preOnInitComponent()
        {
            parent<Component>().usingProxyFromProperty(PROPERTY_NAME);
        }

        void GraspCandidateObserverComponentPlugin::preOnConnectComponent()
        {
            parent<Component>().getProxyFromProperty(_graspCandidateObserver, PROPERTY_NAME);
        }

        void GraspCandidateObserverComponentPlugin::postCreatePropertyDefinitions(armarx::PropertyDefinitionsPtr& properties)
        {
            if (!properties->hasDefinition(PROPERTY_NAME))
            {
                properties->defineOptionalProperty<std::string>(
                    PROPERTY_NAME,
                    "GraspCandidateObserver",
                    "Name of the GraspCandidateObserver");
            }
        }

        grasping::GraspCandidateObserverInterfacePrx GraspCandidateObserverComponentPlugin::getGraspCandidateObserver()
        {
            return _graspCandidateObserver;
        }


    }
}

namespace armarx
{

    GraspCandidateObserverComponentPluginUser::GraspCandidateObserverComponentPluginUser()
    {
        addPlugin(plugin);
    }

    grasping::GraspCandidateObserverInterfacePrx GraspCandidateObserverComponentPluginUser::getGraspCandidateObserver()
    {
        return plugin->getGraspCandidateObserver();
    }


}


