#pragma once

#include <ArmarXCore/core/Component.h>
#include <RobotAPI/interface/observers/GraspCandidateObserverInterface.h>


namespace armarx
{
    namespace plugins
    {

        class GraspCandidateObserverComponentPlugin : public ComponentPlugin
        {
        public:
            using ComponentPlugin::ComponentPlugin;

            void preOnInitComponent() override;

            void preOnConnectComponent() override;

            void postCreatePropertyDefinitions(PropertyDefinitionsPtr& properties) override;

            grasping::GraspCandidateObserverInterfacePrx getGraspCandidateObserver();

        private:
            static constexpr const char* PROPERTY_NAME = "GraspCandidateObserverName";
            grasping::GraspCandidateObserverInterfacePrx _graspCandidateObserver;
        };

    }
}

namespace armarx
{
    /**
     * @brief Provides a ready-to-use GraspCandidateObserver.
     */
    class GraspCandidateObserverComponentPluginUser : virtual public ManagedIceObject
    {
    public:
        GraspCandidateObserverComponentPluginUser();
        grasping::GraspCandidateObserverInterfacePrx getGraspCandidateObserver();

    private:
        armarx::plugins::GraspCandidateObserverComponentPlugin* plugin = nullptr;
    };

}


namespace armarx
{
    namespace plugins
    {
        // Legacy typedef.
        using GraspCandidateObserverComponentPluginUser = armarx::GraspCandidateObserverComponentPluginUser;
    }
}
