/*
 * This file is part of ArmarX.
 *
 * Copyright (C) 2012-2016, High Performance Humanoid Technologies (H2T),
 * Karlsruhe Institute of Technology (KIT), all rights reserved.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Simon Ottenhaus (simon dot ottenhaus at kit dot edu)
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

// STD/STL
#include <memory>
#include <typeindex>
#include <typeinfo>

// ArmarX
#include <ArmarXCore/core/exceptions/Exception.h>

#include <RobotAPI/interface/aron.h>
#include <RobotAPI/libraries/aron/AronConfig.h>
#include <RobotAPI/libraries/aron/AronDescriptor.h>

namespace armarx
{
    namespace aron
    {
        class AronResolver
        {
        private:
            AronResolver() = default;

        public:
            static AronTypeDescriptor GetTypeForAronAbstractType(const AronAbstractTypePtr& a);

            static AronTypeDescriptor GetTypeForAronAbstractTypeId(const std::type_index& a);

            static AronDataDescriptor GetTypeForAronData(const AronDataPtr& a);

            static AronDataDescriptor GetTypeForAronDataTypeId(const std::type_index& a);
        };
    }
}
