/*
* This file is part of ArmarX.
*
* ArmarX is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License version 2 as
* published by the Free Software Foundation.
*
* ArmarX is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*
* @author     Fabian Peller (fabian dot peller at kit dot edu)
* @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
*             GNU General Public License
*/

#pragma once

// STD/STL
#include <memory>
#include <string>

// ArmarX
#include <RobotAPI/libraries/aron/io/AronWriter.h>

using namespace std;

namespace armarx
{
    namespace aron
    {
        namespace io
        {
            template <typename T>
            class AronDataWriter;

            template <typename T>
            using AronDataWriterPtr = std::shared_ptr<AronDataWriter<T>>;

            template <typename T>
            class AronDataWriter :
                    virtual public AronWriter
            {
            public:
                AronDataWriter() = default;

                virtual T getResult() const = 0;

            protected:
            };
        }
    }
}
