/*
 * This file is part of ArmarX.
 *
 * Copyright (C) 2012-2016, High Performance Humanoid Technologies (H2T),
 * Karlsruhe Institute of Technology (KIT), all rights reserved.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Fabian Peller (fabian dot peller at kit dot edu)
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#include "AronJSONWriter.h"

namespace armarx
{
    namespace aron
    {
        namespace io
        {
            void AronJSONWriter::startObject()
            {
                ss << "{";
            }

            void AronJSONWriter::writeObjectBody(const AronObjectNavigatorPtr& navigator)
            {
                for (const AronNavigatorPtr& next : navigator->children())
                {
                    writeNewLine();
                    write(next);
                }
            }

            void AronJSONWriter::endObject()
            {
                ss << "}";
            }

            void AronJSONWriter::startList()
            {
                ss << "[";
            }

            void AronJSONWriter::writeListBody(const AronListNavigatorPtr&)
            {

            }

            void AronJSONWriter::endList()
            {
                ss << "]";
            }

            // TODO
        }
    }
}
